diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -1096,258 +1283,82 @@
 (*                                                                       *)
 (*************************************************************************)
 
-let verify_chunk t i =
-  if t.t_converted_verified_bitmap.[i] = '2' then
-    let nblocks = String.length t.t_converted_verified_bitmap in
+let verify_chunk t j =
+  let verify t uid begin_pos end_pos =
+    file_verify t.t_file uid begin_pos end_pos in
+
+  if t.t_converted_verified_bitmap.[j] = '2' then
+    let nchunks = String.length t.t_converted_verified_bitmap in
     match t.t_verifier with
-      NoVerification
+    | NoVerification
     | VerificationNotAvailable -> ()
 
     | ForceVerification ->
-        set_verified_chunk t i;
-        t.t_verified t.t_nverified_blocks i
-
-    | Verification chunks when Array.length chunks = nblocks ->
+        set_frontend_bitmap_3 t j
 
-        begin try
-            let s = t.t_s in
-            let block_begin = t.t_block_size *.. i in
-            let block_end = block_begin ++ t.t_block_size in
-            let block_end = min block_end s.s_size in
-            if verify t chunks i block_begin block_end then
-	      begin
-                set_verified_chunk t i;
-                t.t_verified t.t_nverified_blocks i;
-                if !verbose_swarming || !verbose then
-      lprintf_nl "Completed block %d/%d of %s"
-                    (i + 1) t.t_nchunks (file_best_name t.t_file)
-              end
-	    else
-	      begin
-                t.t_ncomplete_blocks <- t.t_ncomplete_blocks - 1;
+    | Verification uids when Array.length uids = nchunks ->
 
-                if List.for_all (fun i ->
-                      s.s_verified_bitmap.[i] = '2'
-                  ) t.t_blocks_of_chunk.(i)
-		then
-		  begin
-		    if !verbose_swarming || !verbose then
-                      lprintf_nl "Complete block %d/%d of %s failed verification, reloading..."
-                            (i + 1) t.t_nchunks (file_best_name t.t_file);
-
-                    t.t_converted_verified_bitmap.[i] <- '0';
-
-                    List.iter (fun i ->
-                        match s.s_blocks.(i) with
-                          EmptyBlock -> set_bitmap_0 s i
-                        | PartialBlock _ ->  set_bitmap_1 s i
-                        | CompleteBlock ->
-                            let block_begin = compute_block_begin s i in
-                            let block_end = compute_block_end s i in
-                            add_file_downloaded None s (block_begin -- block_end);
-
-                            s.s_blocks.(i) <- EmptyBlock;
-                            set_bitmap_0 s i
-
-                        | VerifiedBlock -> assert false
-                    ) t.t_blocks_of_chunk.(i)
-                  end
-		else
-		  begin
-		    if !verbose_swarming then begin
-                      let nsub = ref 0 in
-                        lprintf_n "  Swarmer was incomplete: ";
-                        List.iter (fun i ->
-                          lprintf "%c" s.s_verified_bitmap.[i];
-                          if s.s_verified_bitmap.[i] = '2' then incr nsub;
-                        ) t.t_blocks_of_chunk.(i);
-                        lprintf_nl "   = %d/%d" !nsub (List.length t.t_blocks_of_chunk.(i))
-		    end;
-                    t.t_converted_verified_bitmap.[i] <- '1'
-                  end;
-              end
-          with VerifierNotReady -> ()
-        end
+        (try
+          let s = t.t_s in
+          let chunk_begin = t.t_chunk_size *.. j in
+          let chunk_end = chunk_begin ++ t.t_chunk_size in
+          let chunk_end = min chunk_end s.s_size in
+          if verify t uids.(j) chunk_begin chunk_end then
+            set_frontend_bitmap_3 t j
+	  else
+	    set_frontend_bitmap_0 t j
+        with VerifierNotReady -> ())
 
     | Verification chunks ->
+	(* network only provides a hash for the whole file ? *)
         assert (Array.length chunks = 1);
-        let can_verify = ref true in
-        let nblocks= String.length t.t_converted_verified_bitmap in
-        for i = 0 to nblocks - 1 do
-          if t.t_converted_verified_bitmap.[i] < '2' then
-            can_verify := false
-        done;
-        if !can_verify then begin
-            try
-              let s = t.t_s in
-              if verify t chunks 0 zero s.s_size then begin
-                  for i = 0 to nblocks - 1 do
-                    if t.t_converted_verified_bitmap.[i] = '2' then begin
-
-                        set_verified_chunk t i;
-                        t.t_verified t.t_nverified_blocks i;
-                      end
-                  done
-
-              end else begin
-
-                lprintf_nl "Verification of blocks for file %s FAILED\n"
-                    (file_best_name t.t_file);
-
-                  for i = 0 to nblocks - 1 do
-                    if t.t_converted_verified_bitmap.[i] = '2' then begin
-
-                        t.t_ncomplete_blocks <- t.t_ncomplete_blocks - 1;
-                        if List.for_all (fun i ->
-                              s.s_verified_bitmap.[i] = '2'
-                          ) t.t_blocks_of_chunk.(i) then begin
-
-                            t.t_converted_verified_bitmap.[i] <- '0';
-
-                            List.iter (fun i ->
-                                match s.s_blocks.(i) with
-                                  EmptyBlock -> set_bitmap_0 s i
-                                | PartialBlock _ ->  set_bitmap_1 s i
-                                | CompleteBlock ->
-                                    let block_begin = compute_block_begin s i in
-                                    let block_end = compute_block_end s i in
-                                    add_file_downloaded None s (block_begin -- block_end);
-
-                                    s.s_blocks.(i) <- EmptyBlock;
-                                    set_bitmap_0 s i
-
-                                | VerifiedBlock -> assert false
-                            ) t.t_blocks_of_chunk.(i)
-                          end else begin
-                            let nsub = ref 0 in
-
-                            lprintf_n "  Swarmer was incomplete: ";
-                            List.iter (fun i ->
-                                lprintf "%c" s.s_verified_bitmap.[i];
-                                if s.s_verified_bitmap.[i] = '2' then incr nsub;
-                                ) t.t_blocks_of_chunk.(i);
-                            lprintf_nl "   = %d/%d" !nsub (List.length t.t_blocks_of_chunk.(i));
-
-                            t.t_converted_verified_bitmap.[i] <- '1'
-                          end;
-                      end
-                  done
-              end
-          with VerifierNotReady -> ()
-        end
-
+(*        let nchunks = String.length t.t_converted_verified_bitmap in *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         must_verify_chunk (internal)                  *)
-(*                                                                       *)
-(*************************************************************************)
+	if string_for_all (fun x -> x >= '2') t.t_converted_verified_bitmap then
+          try
+            let s = t.t_s in
+            if verify t chunks.(0) zero s.s_size then
+	      string_iter (fun j _ ->
+		set_frontend_bitmap_3 t j
+	      ) t.t_converted_verified_bitmap
+	    else
+	      string_iter (fun j c ->
+		if c = '2' then set_frontend_bitmap_0 t j
+	      ) t.t_converted_verified_bitmap
+          with VerifierNotReady -> ()
 
-            (*
-let must_verify_chunk t i immediatly =
-  match t.t_verifier with
-    NoVerification -> ()
-  | _ ->
-      if t.t_converted_verified_bitmap.[i] < '2' then
-        set_toverify_chunk t i;
-      if t.t_converted_verified_bitmap.[i] = '2' && immediatly then
-        verify_chunk t i
-          *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         must_verify_block                             *)
-(*                                                                       *)
-(*************************************************************************)
+(** mark a block as completed, ready for verification *)
 
-let must_verify_block s i immediatly =
-  set_bitmap_2 s i;
-  if immediatly then
-    match s.s_networks with
-      [] -> assert false
-    | t :: _ when t.t_primary ->
-        let i = t.t_chunk_of_block.(i) in
-        t.t_converted_verified_bitmap.[i] <- '2';
-(*        List.iter (fun j ->
-            if s.s_verified_bitmap.[j] <> '2' then begin
-                lprintf "   block %d not downloaded\n" j;
-                exit_on_error := false;
-              end;
-        ) t.t_blocks_of_chunk.(i);  *)
-        verify_chunk t i;
-(*      exit_on_error := true; *)
-    | _ -> ()
+let must_verify_block s i =
+  set_swarmer_bitmap_2 s i
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         verify_all_blocks                             *)
-(*                                                                       *)
-(*************************************************************************)
+(** mark all blocks as completed, ready for verification *)
 
-let verify_all_chunks t immediatly =
+let verify_all_chunks t =
   let s = t.t_s in
-  for i = 0 to String.length s.s_verified_bitmap - 1 do
-    must_verify_block s i immediatly
-  done
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         compute_bitmap                                *)
-(*                                                                       *)
-(*************************************************************************)
-
-
-let compute_bitmap t =
-  if t.t_ncomplete_blocks > t.t_nverified_blocks then begin
-      for i = 0 to String.length t.t_converted_verified_bitmap - 1 do
-        if t.t_converted_verified_bitmap.[i] = '2' then
-            verify_chunk t i
-      done
-    end
+  string_iter (fun i _ -> must_verify_block s i) s.s_verified_bitmap
 
+(** same, and synchronously calls the verification of all chunks *)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         split_range (internal)                        *)
-(*                                                                       *)
-(*************************************************************************)
+let verify_all_chunks_immediately t =
+  verify_all_chunks t;
+  string_iter (fun i _ -> verify_chunk t i) t.t_converted_verified_bitmap
+    
 
-let rec split_range r range_size =
-  assert (r.range_current_begin = r.range_begin);
-  let next_range = r.range_begin ++ range_size in
-(*  lprintf "   split_range: next_range %Ld\n" next_range; *)
-  if r.range_end > next_range then
-    let rr = {
-        range_block = r.range_block;
-        range_nuploading = 0;
-        range_next = r.range_next;
-        range_prev = Some r;
-        range_begin = next_range;
-        range_current_begin = next_range;
-        range_end = r.range_end;
-      } in
-    begin
-      match r.range_next with
-        None -> ()
-      | Some rrr ->
-(*          lprintf "Another one ??\n"; *)
-          rrr.range_prev <- Some rr;
-    end;
-    r.range_next <- Some rr;
-    r.range_end <- next_range;
-(*    lprintf "      NEW RANGE: %Ld- OLD RANGE: %Ld-%Ld\n"
-      rr.range_begin r.range_begin r.range_end; *)
+(** synchronously verify all completed chunks not yet verified *)
 
-    split_range rr range_size
+let compute_bitmap t =
+  if t.t_ncomplete_chunks > t.t_nverified_chunks then 
+    string_iter (fun i c -> 
+      if c = '2' then verify_chunk t i) t.t_converted_verified_bitmap
 
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         new_block (internal)                          *)
-(*                                                                       *)
-(*************************************************************************)
+(** Replaces the ith block of the swarmer with a PartialBlock
+    ranges are created with s_range_size size *)
 
 let new_block s i =
+
   let block_begin = compute_block_begin s i in
   let block_end = compute_block_end s i in
   let rec b = {
